// WiFi Remote Lチカ・クライアント

#include <WiFi.h>

#define OLDMONITER

#ifdef OLDMONITER
#include "OLED.h"
// OLED用
char str[80] ;
OLED oled ;
#endif

#define SERVERPORT 23
const char* ssid     = "STAMP-PICO";
const char* password = "STAMP-PICO";
const char* host = "192.168.10.10";

#define LED_PIN 26
#define ID_PIN 36
int ledVal = HIGH ;
int clientID = 0 ;

#define BuffMaxLen 80
int readBuffLen = 0 ;
char readBuff[BuffMaxLen] ;

WiFiClient client;

void setup()
{
  delay(10);

  pinMode(LED_PIN,OUTPUT) ;
  digitalWrite(LED_PIN,LOW) ;
  pinMode(ID_PIN,INPUT) ;
  if (digitalRead(ID_PIN) == LOW) {
    clientID = 1 ;
  } else {
    clientID = 2 ;
  }
    
#ifdef OLDMONITER
  // ---- OLED
  oled.init();
  sprintf(str,"Connecting to:%s",ssid) ; oled.Println(str) ;
#else
  Serial.begin(9600);
  Serial.println();
  Serial.println();
  Serial.print("Connecting to ");
  Serial.println(ssid);
#endif

  // We start by connecting to a WiFi network
  WiFi.begin(ssid, password);
  while (WiFi.status() != WL_CONNECTED) {
    delay(500);
#ifdef OLDMONITER
    oled.Print(".");
#else
    Serial.print(".");
#endif
  }

#ifdef OLDMONITER
  oled.Println("WiFi connected");
  oled.Println("IP address: ");
  sprintf(str,"%s",WiFi.localIP().toString()) ; 
  oled.Println(str);
#else
  Serial.println("");
  Serial.println("WiFi connected");
  Serial.println("IP address: ");
  Serial.println(WiFi.localIP());
#endif
}

void loop()
{
  if (WiFi.status() != WL_CONNECTED) {
    // WiFiが切れてたら再接続
    WiFi.begin(ssid, password);
    while (WiFi.status() != WL_CONNECTED) {
      delay(500);
#ifdef OLDMONITER
      oled.Print(".");
#else
      Serial.print(".");
#endif
    }
#ifdef OLDMONITER
    oled.Println("connecting to ");
    sprintf(str,"%s",host) ; 
    oled.Println(str);
    oled.Println("IP address: ");
    sprintf(str,"%s",WiFi.localIP().toString()) ; 
    oled.Println(str);
#else
    Serial.print("connecting to ");
    Serial.println(host);
    Serial.println("IP address: ");
    Serial.println(WiFi.localIP());
#endif
  }

  // Use WiFiClient class to create TCP connections
  if (!client.connected( ) ) {
    if (!client.connect(host, SERVERPORT)) {
#ifdef OLDMONITER
      oled.Println("connection failed");
#else
      Serial.println("connection failed");
#endif
      return;
    }
  }

  // This will send the request to the server
  ledVal = (ledVal == HIGH) ? LOW : HIGH ;
  digitalWrite(LED_PIN,ledVal) ;

  sprintf(str,"LED%d:%s\n",clientID,((ledVal==HIGH)?"ON":"OFF")) ;
  client.println(str);
#ifdef OLDMONITER
  oled.Print("SEND ");
  oled.Println(str);
#else
  Serial.print("SEND ");
  Serial.println(str);
#endif

  for (int w = 0 ; w < 6 ; w++) {
    delay(500);
    // Read all the lines of the reply from server and print them to Serial
    while(client.available()) {
      char c = client.read();  // store the read a byte.
      if (c == '\n' || readBuffLen+1 >= BuffMaxLen) {
        readBuff[readBuffLen] = '\0' ;
        readBuffLen = 0 ;
#ifdef OLDMONITER
      oled.Println(readBuff);
#else
      Serial.println(readBuff);
#endif
      } else {
        if (c >= ' ') {
          readBuff[readBuffLen] = c ;
          readBuffLen ++ ;
        }
      }
    }
  }
}
