/*
 * SSD1306 128x64に 6x8のASCIIフォントを表示
 * 
 */
#ifndef _OLED_H_
#define _OLED_H_

#include <Wire.h>
#include "font6x8.h"
#include "font8x16.h"

class OLED
{
  private:
    int cursorX ;
    int cursorY ;
    int consoleW ;
    int consoleH ;
    int fontSize ;  // 1:6x8 2:8x16
    uint8_t DisplayBuff[21*8] ;    // スクロール用キャラクラRAM領域(21*8 or 16x4)

  public:
    void init(); // 初期化
    void cls(); // 画面クリア
    void dispSwitch(bool sw) ;
    void Print(char *str) { Print(str, false); }  // 文字列表示
    void Println(char *str) { Print(str, true); } // 文字列表示
    void PrintCR() ;

  protected:
    void oledSendCommand(uint8_t command); // OLEDに1バイトコマンドを送信
    void oledSendCommand2(uint8_t command1, uint8_t command2); // OLEDに2バイトコマンドを送信
    void oledSendCommand3(uint8_t command1, uint8_t command2,uint8_t command3); // OLEDに3バイトコマンドを送信
    void oledSendCommands(int commandLen, uint8_t commands[]); // OLEDに複数のコマンドを送信

    void oledBitMap(int offsetX, int offsetY, int width, int hight, uint8_t *bitMap) ;
    void oledBitMap32(int col, int row, int width, uint8_t *bitMap) ;

    void clsOLED() ;
    void Print(char *str,bool flagCR); // 文字列表示
    void PrintASCII(uint8_t asciiCode,bool flagCR) ;
    void scroll( ) ;
} ;
#endif
